/***
 * OW2 FraSCAti Generate Assembly Factory
 * Copyright (C) 2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Author: Pierre Carton
 */
package org.ow2.frascati.factory.core.backend;

import java.net.URI;
import java.net.URL;

import org.objectweb.fractal.fraclet.annotations.Component;
import org.objectweb.fractal.fraclet.annotations.Requires;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.Type;
import org.ow2.frascati.factory.core.instance.runtime.RuntimeFactory;
//import org.objectweb.fractal.bf.BindingFactory;

/**
 * Link against Generate factory and Fractal
 * in standard mode
 * @author <a href="mailto:pierre.carton@inria.fr">Pierre Carton</a>
 * @version $Revision$
 */

@Component
public class WritterRuntimeBackend implements RuntimeFactory{



	/*
	 * 
	 */
	@Requires(name = "runtimeClient")
	RuntimeFactory runtime;

	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString(){
		return "StandardGeneratedFactoryBackend";
	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.backend.FactoryBackend#newFcInstance(org.objectweb.fractal.api.Type, java.lang.Object, java.lang.Object)
	 */
	public org.objectweb.fractal.api.Component newFcInstance(Type arg0,Object arg1, Object arg2) throws InstantiationException {
		return runtime.newFcInstance(arg0, arg1,arg2);

	}

		/*
		 * (non-Javadoc)
		 * @see org.ow2.frascati.factory.core.backend.FactoryBackend#createFcType(org.objectweb.fractal.api.type.InterfaceType[])
		 */
	public ComponentType createFcType(InterfaceType[] arg0) throws InstantiationException{
		return runtime.createFcType(arg0);

	}


	/*
	 * (non-Javadoc)
	 * @see org.objectweb.fractal.api.type.TypeFactory#createFcItfType(java.lang.String, java.lang.String, boolean, boolean, boolean)
	 */
	public InterfaceType createFcItfType(String name, String signature,boolean isClient, boolean isOptional, boolean isCollection)
	throws InstantiationException {
		return runtime.createFcItfType(name, signature, isClient, isOptional, isCollection);
	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.instance.runtime.FactoryLoaderItf#getClassLoader()
	 */
	public ClassLoader getClassLoader() {
		return runtime.getClassLoader();
	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.instance.runtime.FactoryLoaderItf#getCompositeResource(java.lang.String)
	 */
	public URI getCompositeResource(String compositeFile) {
		return runtime.getCompositeResource(compositeFile);
	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.instance.runtime.FactoryLoaderItf#getFactoryClassLoader()
	 */
	public ClassLoader getFactoryClassLoader() {
		return runtime.getClassLoader();
	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.instance.runtime.FactoryLoaderItf#loadLibraries(java.net.URL[])
	 */
	public void loadLibraries(URL[] urls) {
		runtime.loadLibraries(urls);

	}

	/*
	 * (non-Javadoc)
	 * @see org.ow2.frascati.factory.core.instance.runtime.FactoryLoaderItf#setClassLoader(java.lang.ClassLoader)
	 */
	public void setClassLoader(ClassLoader classloader) {
		runtime.setClassLoader(classloader);

	}

}
